/**
 * 
 */
package org.gcube.portlets.user.dataminermanager.client.bean.parameters;

import java.io.Serializable;
import java.util.ArrayList;


/**
 * @author ceras
 *
 */
public class TabularListParameter extends Parameter implements Serializable {

	private static final long serialVersionUID = -1786477950530892502L;
	private String value;
	private String separator;
	private ArrayList<String> templates = new ArrayList<String>();
	//private List<String> tableNames = new ArrayList<String>();


	public TabularListParameter() {
		super();
		this.typology = ParameterTypology.TABULAR_LIST;
	}

	/**
	 * @param defaultValue
	 * @param value
	 */
	public TabularListParameter(String name, String description, String separator) {
		super(name, ParameterTypology.TABULAR_LIST, description);
		this.separator = separator;
	}
	
	
	@Override
	public void setValue(String value) {
		this.value = value;
	}
		
	
	@Override
	public String getValue() {
		return value;
	}
	
	/**
	 * @return the separator
	 */
	public String getSeparator() {
		return separator;
	}
	
	/**
	 * @param templates the templates to set
	 */
	public void setTemplates(ArrayList<String> templates) {
		this.templates = templates;
	}
	
	/**
	 * @return the templates
	 */
	public ArrayList<String> getTemplates() {
		return templates;
	}
	
	public void addTemplate(String template) {
		templates.add(template);
	}

	@Override
	public String toString() {
		return "TabularListParameter [value=" + value + ", separator="
				+ separator + ", templates=" + templates + ", name=" + name
				+ ", description=" + description + ", typology=" + typology
				+ "]";
	}
	
	
	

}
