/**
 * 
 */
package org.gcube.portlets.user.dataminermanager.client.bean.parameters;

import java.io.Serializable;
import java.util.ArrayList;

/**
 * @author ceras
 *
 */
public class TabularParameter extends Parameter implements Serializable {

	private static final long serialVersionUID = 8038591467145151553L;
	private String tableName;
	private ArrayList<String> templates = new ArrayList<String>();

	/**
	 * 
	 */
	public TabularParameter() {
		super();
		this.typology = ParameterTypology.TABULAR;
	}

	
	/**
	 * 
	 * @param name
	 * @param description
	 * @param tableName
	 */
	public TabularParameter(String name, String description, String tableName) {
		super(name, ParameterTypology.TABULAR, description);
		this.tableName = tableName;
		this.templates = null;
	}

	/**
	 * 
	 * @param name
	 * @param description
	 * @param tableName
	 * @param templates
	 */
	public TabularParameter(String name, String description, String tableName,
			ArrayList<String> templates) {
		super(name, ParameterTypology.TABULAR, description);
		this.tableName = tableName;
		this.templates = templates;
	}

	public String getTableName() {
		return tableName;
	}

	public void setTableName(String tableName) {
		this.tableName = tableName;
	}

	public ArrayList<String> getTemplates() {
		return templates;
	}

	public void setTemplates(ArrayList<String> templates) {
		this.templates = templates;
	}

	@Override
	public String getValue() {
		return getTableName();
	}

	@Override
	public void setValue(String value) {
		this.setTableName(value);
	}

	@Override
	public String toString() {
		return "TabularParameter [tableName=" + tableName + ", templates="
				+ templates + ", name=" + name + ", description=" + description
				+ ", typology=" + typology + "]";
	}

}
