package org.gcube.portlets.user.dataminermanager.client.rpc;

import java.util.List;
import java.util.Map;

import org.gcube.portlets.user.dataminermanager.client.bean.ComputationStatus;
import org.gcube.portlets.user.dataminermanager.client.bean.Operator;
import org.gcube.portlets.user.dataminermanager.client.bean.OperatorsClassification;
import org.gcube.portlets.user.dataminermanager.client.bean.output.ImagesResource;
import org.gcube.portlets.user.dataminermanager.client.bean.output.MapResource;
import org.gcube.portlets.user.dataminermanager.client.bean.output.Resource;
import org.gcube.portlets.user.dataminermanager.client.bean.parameters.Parameter;
import org.gcube.portlets.user.dataminermanager.shared.data.ComputationId;
import org.gcube.portlets.user.dataminermanager.shared.data.TableItemSimple;
import org.gcube.portlets.user.dataminermanager.shared.session.UserInfo;
import org.gcube.portlets.user.dataminermanager.shared.workspace.DataMinerWorkArea;
import org.gcube.portlets.user.dataminermanager.shared.workspace.ItemDescription;
import org.gcube.portlets.widgets.wsexplorer.shared.Item;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;

/**
 * 
 * @author Giancarlo Panichi
 * email: <a href="mailto:g.panichi@isti.cnr.it">g.panichi@isti.cnr.it</a> 
 *
 */
public interface DataMinerPortletServiceAsync {
	
	public static DataMinerPortletServiceAsync INSTANCE = (DataMinerPortletServiceAsync) GWT
			.create(DataMinerPortletService.class);

	/*
	void getTableItems(List<String> templates,
			AsyncCallback<List<TableItemSimple>> callback);
	*/
	void getFileItems(List<String> templates,
			AsyncCallback<List<TableItemSimple>> callback);

	
	void getResourceByComputationId(ComputationId computationId,
			AsyncCallback<Resource> callback);

	void getMapFromMapResource(MapResource mapResource,
			AsyncCallback<Map<String, Resource>> callback);

	void getParametersMapByComputationId(ComputationId computationId,
			AsyncCallback<Map<String, String>> callback);

	void saveImage(ComputationId computationId, ImagesResource imageResource,
			AsyncCallback<String> callback);

	void removeResource(String id, AsyncCallback<Void> callback);

	void removeImport(String id, AsyncCallback<Void> callback);

	
	/**
	 * DataMiner 
	 *
	 */
	void hello(AsyncCallback<UserInfo> callback);

	void getOperatorsClassifications(
			AsyncCallback<List<OperatorsClassification>> callback);

	void getParameters(Operator operator,
			AsyncCallback<List<Parameter>> callback);	
	
	void startComputation(Operator op, String computationTitle,
			String computationDescription,
			AsyncCallback<ComputationId> asyncCallback);

	void getComputationStatus(ComputationId computationId,
			AsyncCallback<ComputationStatus> asyncCallback);
	
	void resubmit(ComputationId computationId, AsyncCallback<ComputationId> callback);

	void retrieveTableInformation(Item item, AsyncCallback<TableItemSimple> callback);

	void getDataMinerWorkArea(AsyncCallback<DataMinerWorkArea> asyncCallback);

	void getPublicLink(ItemDescription itemDescription,
			AsyncCallback<String> callback);

	void cancelComputation(ComputationId computationId,
			AsyncCallback<String> asyncCallback);

	
}
